---
title: "Setting ChatGPT LLM Responses"
url: "https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post/"
date: "2026-06-06"
---

## Setting ChatGPT LLM Responses

  
ChatGPT LLM Responses endpoint allows you to retrieve structured responses from a specific ChatGPT model, based on the input parameters.

This is the Standard method of data retrieval. If you don’t need to receive data in real-time, this method is the best option for you. Set a task and retrieve the results when our system collects them. Execution time depends on the system workload.

If your system requires delivering instant results, [the Live method](https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/live.md) will be a better solution. This method doesn’t require making separate POST and GET requests to the corresponding endpoints.

Note that this endpoint requires making an automatic prepayment of $0.01 to execute the task. If the cost charged by the LLM is less than $0.01, the difference will be refunded to your account balance.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/ai\_optimization/chat\_gpt/llm\_responses/task\_post     

      

Pricing

  Your account will be charged only for setting a task.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/ai-optimization/llm-responses "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). Task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the `40006` error.

Tasks using the Standard method **may take up to 72 hours to complete**. If the task is not completed within this time, it is marked as failed, and the $0.01 advance is refunded. It is also important to note that if your account balance is negative, you will not receive the results even if the task is completed successfully.

You can also retrieve the results of completed tasks using the unique task identifier `id`. Alternatively, we can send them to you as soon as they are ready if you specify the `postback_url` or `pingback_url` when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the [tasks\_ready](https://docs.dataforseo.com/v3/keywords_data/google_ads/search_volume/tasks_ready.md) list. The error code and message depend on your server’s configuration.

See [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) to learn more about using pingbacks and postbacks with DataForSEO APIs.

Below you will find a detailed description of the fields you can use for setting a task.

**Description of the fields for setting a task:**

| Field name | Type | Description |
|---|---|---|
| `user_prompt` | string | *prompt for the AI model*   **required field**   the question or task you want to send to the AI model;   you can specify **up to 500 characters** in the `user_prompt` field |
| `model_name` | string | *name of the AI model*   **required field**   `model_name`consists of the actual model name and version name;   if the basic model name is specified, its latest version will be set by default;   for example, if `gpt-4.1` is specified, the `gpt-4.1-2025-04-14` will be set as `model_name` automatically;   you can receive the list of available LLM models by making a separate request to the `https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/models` |
| `max_output_tokens` | integer | *maximum number of tokens in the AI response*   optional field   minimum value for reasoning models (e.g., `reasoning` is `true` in the [Models endpoint](https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/models.md)): `1024`;   minimum value for non-reasoning models: `16`;   maximum value: `4096`;   default value: `2048` |
| `temperature` | float | *randomness of the AI response*   optional field   higher values make output more diverse;    lower values make output more focused;   minimum value: `0`   maximum value: `2`   default value: `0.94`   **Note:** not supported in reasoning models |
| `top_p` | float | *diversity of the AI response*   optional field    controls diversity of the response by limiting token selection;   minimum value: `0`   maximum value: `1`    default value: `0.92`  **Note:** `top_p` cannot be used together with `temperature` in the same request |
| `web_search` | boolean | *enable web search*   optional field   when enabled, the AI model can access and cite current web information;   default value: `false`;   **Note:** refer to the [Models endpoint](https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/models.md) for a list of models that support `web_search`; |
| `force_web_search` | boolean | *force AI agent to use web search*   optional field   to enable this parameter, `web_search` must also be enabled;   when enabled, the AI model is forced to access and cite current web information;   default value: `false`;   **Note:** even if the parameter is set to `true`, there is no guarantee web sources will be cited in the response    **Note #2:** not supported in reasoning models |
| `web_search_country_iso_code` | string | *ISO country code of the location*   optional field   to enable this parameter, `web_search` must also be enabled;   when enabled, the AI model will search the web from the country you specify;   **Note:** not supported in `o3-mini`, `o1-pro`, `o1` models |
| `web_search_city` | string | *city name of the location*   optional field   **Note:** not supported in `o3-mini`, `o1-pro`, `o1` models |
| `system_message` | string | *instructions for the AI behaviour*   optional field   defines the AI's role, tone, or specific behavior;   you can specify **up to 500 characters** in the `system_message` field |
| `message_chain` | array | *conversation history*   optional field   array of message objects representing previous conversation turns;   each object must contain `role` and `message` parameters:   `role` string with either `user` or `ai` role;   `message` string with message content (max 500 characters);   you can specify  **the maximum of 10 message objects** in the array;   example:   `"message_chain": [{"role":"user","message":"Hello, what’s up?"},{"role":"ai","message":"Hello! I’m doing well, thank you. How can I assist you today?"}]` |
| `postback_url` | string | *URL for sending task results*   optional field   once the task is completed, we will send a POST request with its results compressed in the `gzip` format to the `postback_url` you specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request.   example:   `http://your-server.com/postbackscript?id=$id`   `http://your-server.com/postbackscript?id=$id&tag=$tag`   **Note:** special character in `postback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`  learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `pingback_url` | string | *notification URL of a completed task*   optional field   when a task is completed we will notify you by GET request sent to the URL you have specified   you can use the ‘$id’ string as a `$id` variable and ‘$tag’ as urlencoded `$tag` variable. We will set the necessary values before sending the request   example:   `http://your-server.com/pingscript?id=$id`   `http://your-server.com/pingscript?id=$id&tag=$tag`   **Note:** special character in `pingback_url` will be urlencoded;   i.a., the `#` character will be encoded into `%23`  learn more on our [Help Center](https://dataforseo.com/help-center/pingbacks-postbacks-with-dataforseo-api) |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` array of the response |



  
 As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks.

**Description of the fields in the results array:**

| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total tasks cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`**array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *unique task identifier in our system*   **unique task identifier in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*    generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of response codes [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix-errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results*   in this case, the value will be `null` |



 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "system_message": "communicate as if we are in a business meeting",
    "message_chain": [
      {
        "role": "user",
        "message": "Hello, what’s up?"
      },
      {
        "role": "ai",
        "message": "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
      }
    ],
    "model_name": "gpt-4.1-mini",
    "user_prompt": "provide information on how relevant the amusement park business is in France now"
  }
]'
```





```php
<?php

/**
 * Method: POST
 * Endpoint: https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post
 * @see https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post
 */

require_once __DIR__ . '/../../../../../lib/RestClient.php';
$config = require __DIR__ . '/../../../../../lib/config.php';

$client = new RestClient($config['base_url'], null, $config['login'], $config['password']);

$data = [
    [
        'system_message' => 'communicate as if we are in a business meeting',
        'message_chain' => [
            [
                'role' =>'user',
                'message' => 'Hello, what's up?',
            ],
            [
                'role' => 'ai',
                'message' =>; 'Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?',
            ],
        ],
        'model_name' => 'gpt-4.1-mini',
        'user_prompt' => 'provide information on how relevant the amusement park business is in France now',
    ],
];
try {
    $result = $client->post('/v3/ai_optimization/chat_gpt/llm_responses/task_post', $data);
    print_r($result);
    // do something with post result
} catch (RestClientException $e) {
    printf(
        "HTTP code: %dnError code: %dnMessage: %snTrace: %sn",
        $e->getHttpCode(),
        $e->getCode(),
        $e->getMessage(),
        $e->getTraceAsString()
    );
}
?>
```





```js
const post_array = [];

post_array.push({
  "system_message": "communicate as if we are in a business meeting",
    "message_chain": [
      {
        "role": "user",
        "message": "Hello, what’s up?"
      },
      {
        "role": "ai",
        "message": "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
      }
    ],
    "model_name": "gpt-4.1-mini",
    "user_prompt": "provide information on how relevant the amusement park business is in France now"
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
```





```
"""
Method: POST
Endpoint: https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post
@see https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post
"""

import sys
import os
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '../../../../../')))
from lib.client import RestClient
from lib.config import username, password
client = RestClient(username, password)

post_data = []
post_data.append({
        'system_message': 'communicate as if we are in a business meeting',
        'message_chain': [
            {
                'role': 'user',
                'message': 'Hello, what's up?'
            },
            {
                'role': 'ai',
                'message': 'Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?'
            }
        ],
        'model_name': 'gpt-4.1-mini',
        'user_prompt': 'provide information on how relevant the amusement park business is in France now'
    })
try:
    response = client.post('/v3/ai_optimization/chat_gpt/llm_responses/task_post', post_data)
    print(response)
    # do something with post result
except Exception as e:
    print(f'An error occurred: {e}')
```





```csharp
using System;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Collections.Generic;
using System.Threading.Tasks;
using Newtonsoft.Json;
namespace DataForSeoSdk;

public class AiOptimization
{

    private static readonly HttpClient _httpClient;
    
    static AiOptimization()
    {
        _httpClient = new HttpClient
        {
            BaseAddress = new Uri("https://api.dataforseo.com/")
        };
        _httpClient.DefaultRequestHeaders.Authorization =
            new AuthenticationHeaderValue("Basic", ApiConfig.Base64Auth);
    }
    /// <summary>
    /// Method: POST
    /// Endpoint: https://api.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post
    /// </summary>
    /// <see href="https://docs.dataforseo.com/v3/ai_optimization/chat_gpt/llm_responses/task_post"/>
    
    public static async Task ChatGPTLlmResponsesTaskPost()
    {
        var postData = new List<object>();
        // a simple way to set a task, the full list of possible parameters is available in documentation
        postData.Add(new
        {
            system_message = "communicate as if we are in a business meeting",
            message_chain = new object[]
            {
                new
                {
                    role = "user",
                    message = "Hello, what's up?"
                },
                new
                {
                    role = "ai",
                    message = "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
                }
            },
            max_output_tokens = 1024,
            temperature = 0.3,
            top_p = 0.5,
            model_name = "gpt-4.1-mini",
            user_prompt = "provide information on how relevant the amusement park business is in France now"
        });

        var content = new StringContent(JsonConvert.SerializeObject(postData), Encoding.UTF8, "application/json");
        using var response = await _httpClient.PostAsync("/v3/ai_optimization/chat_gpt/llm_responses/task_post", content);
        var result = JsonConvert.DeserializeObject<dynamic>(await response.Content.ReadAsStringAsync());
        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
        if (result.status_code == 20000)
        {
            // do something with result
            Console.WriteLine(result);
        }
        else
            Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
    }
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20250526",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.1071 sec.",
  "cost": 0.0102,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07151610-0696-0613-0000-b2366402ce99",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0146 sec.",
      "cost": 0.0102,
      "result_count": 0,
      "path": [
        "v3",
        "ai_optimization",
        "chat_gpt",
        "llm_responses",
        "task_post"
      ],
      "data": {
        "api": "ai_optimization",
        "function": "llm_responses",
        "se": "chat_gpt",
        "system_message": "communicate as if we are in a business meeting",
        "message_chain": [
          {
            "role": "user",
            "message": "Hello, what's up?"
          },
          {
            "role": "ai",
            "message": "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
          }
        ],
        "model_name": "gpt-4.1-mini",
        "user_prompt": "provide information on how relevant the amusement park business is in France now"
      },
      "result": null
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp